Name:           jabref
Version:        2.4.2
Release:        1%{?dist}
Summary:        Graphical frontend to manage BibTeX bibliographical databases
License:        GPLv2
Group:          Applications/Publishing
Url:            http://jabref.sourceforge.net/

Source0:        http://jaist.dl.sourceforge.net/sourceforge/jabref/JabRef-%{version}-src.tar.bz2
Source1:        jabref.desktop
Source2:        jabref

# Clean up the build a bit
Patch0:  jabref-2.4.2-build_xml.patch
# Regenerate the antlr parser with a more modern version of antlr3
Patch1:  jabref-2.4.2-antlr.patch
# Remove the calls to the bundled "wsi" packages
Patch2:  jabref-2.4.2-remove-wsi.patch
# Remove the explicit use of the Windows L&F
Patch3:  jabref-2.4.2-remove-windows.patch
# Fix a weird issue where a field isn't available
Patch4:  jabref-2.4.2-pane.patch
# Remove all uses of the Java Plugin Framework (not currently available)
Patch5:  jabref-2.4.2-remove-plugin.patch

Requires: java >= 0:1.4.2
Requires: jgoodies-looks
Requires: jgoodies-forms

BuildRequires:  ant
BuildRequires:  antlr, antlr3, stringtemplate
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  jgoodies-looks
BuildRequires:  jgoodies-forms
BuildRequires:  spin
BuildRequires:  glazedlists
BuildRequires:  antlr
BuildRequires:  jakarta-commons-logging
BuildRequires:  microba
BuildRequires:  jempbox, pdfbox
BuildRequires:  ritopt

BuildArch: noarch

BuildRoot:        %{_tmppath}/%{name}-%{version}-buildroot

%description
JabRef is a graphical frontend to manage BibTeX databases, the standard
LaTeX bibliography reference format. JabRef is build to be platform
independent (requires Java >= 1.4.2). It merges and extends the
functionalities of BibKeeper (Morten O. Alver) and JBibtexManager (Nizar
Batada).

%prep
%setup -q
%patch0 -p1
# Remove all pre-built jar files, but leave the directory structure and the EndNote filters
rm -rf lib/*.jar lib/*.class lib/plugin/*.jar

# Regenerate the antlr parser
rm -f src/java/net/sf/jabref/bst/Bst*.java
%patch1 -p1
mv src/java/net/sf/jabref/bst/bst.g src/java/net/sf/jabref/bst/Bst.g
java -cp `build-classpath antlr antlr3 stringtemplate` org.antlr.Tool src/java/net/sf/jabref/bst/Bst.g

# Remove bundled packages and clean up the source
rm -rf src/java/com src/java/wsi src/java/gnu
%patch2 -p1
%patch3 -p1
%patch4 -p1

# Remove all uses of the Java Plugin Framework
rm -rf src/java/net/sf/jabref/export/PluginBasedExportFormat.java src/java/net/sf/jabref/plugin
%patch5 -p1

# Fix one file permission
chmod a-x src/txt/gpl.txt


%build
export CLASSPATH=`build-classpath jgoodies-looks jgoodies-forms spin glazedlists antlr antlr3 microba pdfbox ritopt jgoodies-looks-demo jempbox`
ant

%install
rm -rf $RPM_BUILD_ROOT
# Install Java stuff
mkdir -p ${RPM_BUILD_ROOT}%{_javadir}
cp -p build/lib/JabRef-2.4.2.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

# Install desktop file, icon, and shell script
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/
cp -p src/images/JabRef-icon-48.png \
        ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/jabref.png
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
cp -p %{SOURCE2} ${RPM_BUILD_ROOT}%{_bindir}
desktop-file-install \
        --dir=${RPM_BUILD_ROOT}%{_datadir}/applications \
        %{SOURCE1}

%post -p /usr/bin/update-desktop-database

%postun -p /usr/bin/update-desktop-database

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc src/txt/CHANGELOG src/txt/gpl.txt src/txt/README src/txt/TODO
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_javadir}/%{name}*.jar
%attr(755,root,root) %{_bindir}/%{name}

%changelog
* Thu Jan 29 2009 Mary Ellen Foster <mefoster at gmail.com> - 2.4.2-1
- Initial package, based on one written by John Pye in 2006
